/*
//@HEADER
// ***********************************************************************
//
//       Ifpack2: Templated Object-Oriented Algebraic Preconditioner Package
//                 Copyright (2009) Sandia Corporation
//
// Under terms of Contract DE-AC04-94AL85000, there is a non-exclusive
// license for use of this work by or on behalf of the U.S. Government.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are
// met:
//
// 1. Redistributions of source code must retain the above copyright
// notice, this list of conditions and the following disclaimer.
//
// 2. Redistributions in binary form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// 3. Neither the name of the Corporation nor the names of the
// contributors may be used to endorse or promote products derived from
// this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
// EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// Questions? Contact Michael A. Heroux (maherou@sandia.gov)
//
// ***********************************************************************
//@HEADER
*/

// WARNING: This file is automatically generated by CMake, and written
// to Trilinos' build (not source) directory.  DO NOT EDIT THIS FILE!
// If you run CMake again, it will overwrite any changes that you
// made.  Furthermore, it would be unwise to assume anything about
// this file: it may disappear at any time, and its name, location, or
// contents may change at any time.

#include "TpetraCore_config.h"
#include "Ifpack2_config.h"

#if defined(HAVE_IFPACK2_EXPLICIT_INSTANTIATION) && defined(HAVE_TPETRA_INST_DOUBLE) && defined(HAVE_TPETRA_INST_INT_LONG_LONG) && defined(HAVE_TPETRA_INST_OPENMP)

// We need both the decl and def files here, because if ETI is ON,
// then the (automatically generated) .hpp file will only include the
// _decl.hpp file.
#include "Ifpack2_Details_LinearSolverFactory_decl.hpp"
#include "Ifpack2_Details_LinearSolverFactory_def.hpp"
#include "Ifpack2_ETIHelperMacros.h"

// Define the Ifpack2 ETI macros and Tpetra typedefs that go along
// with them.
IFPACK2_ETI_MANGLING_TYPEDEFS()

// Do explicit instantiation of Ifpack2::Details::LinearSolverFactory,
// for Tpetra objects, with the given Tpetra template parameters.
IFPACK2_DETAILS_LINEARSOLVERFACTORY_INSTANT( double, int, longlong, Kokkos_Compat_KokkosOpenMPWrapperNode )

#endif
